// {{{RME classifier 'Logical View::Basic::IdProvider'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "IdProvider.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>
#include <IdProvider.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR
// }}}USR
// }}}RME

static void rtg_IdProvider_init( const RTObject_class * type, IdProvider * target )
{
	(void)new( target ) IdProvider;
}

static void rtg_IdProvider_copy( const RTObject_class * type, IdProvider * target, const IdProvider * source )
{
	(void)new( target ) IdProvider( *source );
}

static void rtg_IdProvider_destroy( const RTObject_class * type, IdProvider * target )
{
	target->~IdProvider();
}

const RTObject_class RTType_IdProvider =
{
	(const RTObject_class *)0
  , (RTSuperAccessFunction)0
  , "IdProvider"
  , (RTVersionId)0
  , (RTFieldOffset)sizeof( IdProvider )
  , (RTInitFunction)rtg_IdProvider_init
  , (RTCopyFunction)rtg_IdProvider_copy
#if OBJECT_DECODE
  , RTstruct_decode
#endif
#if OBJECT_ENCODE
  , RTstruct_encode
#endif
  , (RTDestroyFunction)rtg_IdProvider_destroy
  , 0
  , (const RTFieldDescriptor *)0
};

// {{{RME classAttribute 'nextId'
int IdProvider::nextId ( 0 );
// }}}RME

// {{{RME tool 'OT::Cpp' property 'GenerateDefaultConstructor'
IdProvider::IdProvider( void )
{
}
// }}}RME

// {{{RME tool 'OT::Cpp' property 'GenerateDestructor'
IdProvider::~IdProvider( void )
{
}
// }}}RME

// {{{RME tool 'OT::Cpp' property 'GenerateCopyConstructor'
IdProvider::IdProvider( const IdProvider & rtg_arg )
{
}
// }}}RME

// {{{RME tool 'OT::Cpp' property 'GenerateAssignmentOperator'
IdProvider & IdProvider::operator=( const IdProvider & rtg_arg )
{
	if( this != &rtg_arg )
	{
	}
	return *this;
}
// }}}RME

// {{{RME operation 'get()'
int IdProvider::get( void )
{
	// {{{USR
	nextId++;
	return nextId;
	// }}}USR
}
// }}}RME

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR
// }}}USR
// }}}RME

// }}}RME
