// {{{RME classifier 'Logical View::Basic::IdProvider'

#ifndef IdProvider_H
#define IdProvider_H

#ifdef PRAGMA
#pragma interface "IdProvider.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
// }}}USR
// }}}RME

extern const RTObject_class RTType_IdProvider;

class IdProvider
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR
	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR
	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR
	// }}}USR
	// }}}RME

protected:
	// {{{RME classAttribute 'nextId'
	static int nextId;
	// }}}RME

public:
	// {{{RME tool 'OT::Cpp' property 'GenerateDefaultConstructor'
	IdProvider( void );
	// }}}RME
	// {{{RME tool 'OT::Cpp' property 'GenerateDestructor'
	virtual ~IdProvider( void );
	// }}}RME
	// {{{RME tool 'OT::Cpp' property 'GenerateCopyConstructor'
	IdProvider( const IdProvider & rtg_arg );
	// }}}RME
	// {{{RME tool 'OT::Cpp' property 'GenerateAssignmentOperator'
	IdProvider & operator=( const IdProvider & rtg_arg );
	// }}}RME
	// {{{RME operation 'get()'
	int get( void );
	// }}}RME
};

struct RTTypedValue_IdProvider
{
	const void * data;
	const RTObject_class * type;
	inline RTTypedValue_IdProvider( const IdProvider & rtg_value )
		: data( &rtg_value ), type( &RTType_IdProvider )
	{
	}
	inline RTTypedValue_IdProvider( const IdProvider & rtg_value, const RTObject_class * rtg_type )
		: data( &rtg_value ), type( rtg_type )
	{
	}
	inline ~RTTypedValue_IdProvider( void )
	{
	}
};

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR
// }}}USR
// }}}RME

#endif /* IdProvider_H */

// }}}RME
