// {{{RME classifier 'Logical View::VariantAustrian::IntersectionAustrian'

#ifndef IntersectionAustrian_H
#define IntersectionAustrian_H

#ifdef PRAGMA
#pragma interface "IntersectionAustrian.h"
#endif

#include <RTSystem/AustrianIntersection_x86gcc.h>
#include <Intersection.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR
// }}}USR
// }}}RME

extern const RTActorClass IntersectionAustrian;

#define SUPER Intersection_Actor
class IntersectionAustrian_Actor : public Intersection_Actor
{
protected:
	// {{{RME capsuleRole 'walkLightR1'
	RTActorRef walkLightR1;
	// }}}RME

public:
	IntersectionAustrian_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~IntersectionAustrian_Actor( void );
	virtual int _followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex );
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTComponentDescriptor rtg_capsule_roles[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR
// }}}USR
// }}}RME

#endif /* IntersectionAustrian_H */

// }}}RME
